<?
/*
	XTP (XORE TRACKER PHP) 2006
	WRITTEN FOR HIGHSPEED SERVERS THAT ARE CAPABLE EACCELERATOR
	
	CONFIG GUIDELINES (RECOMENDED)
	-----------------------------------------------------------------------------------------------------
	
	RECOMENDED SERVER HARDWARE SPECS:
	LINUX (ANY DISTRO WITHOUT GUI'S)
	AT LEAST 1GB RAM
	AT LEAST P4 3.0 GHZ / OR SIMILAIR XEON ETC..
	
	RECOMENDED SERVER SOFTWARE SPECS:
	PHP4 => FASTER THEN PHP5
	PHP FASTCGI
	LIGHTTPD WITH FASTCGI SUPPORT
	EACCELERATOR (CONFIGURE TO GET THE MOST OUT OF IT)
	
	SERVER CONFIG TIPS:
	TURN OF LOGGING FOR: PHP, EACCELERATOR,LIGHTTPD
	OPTIMIZE YOUR SYSCTL.CONF
*/

error_reporting(1);
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html>
<head>
<meta http-equiv="content-type" content="text/html; charset=iso-8859-1" />
<title>XTP Tracker Version 1</title>
<style>
body{margin:0.5em;padding:0.3em;color:#000;font: small sans-serif;background:#fff;}
table{width:100%;border-collapse:collapse;border:1px solid #ccc;text-align:left}
th{background-color:#fafafa;border:1px solid #ccc}
td{border:1px solid #ccc}
tr:hover{background-color:#fafafa}
a{color:#000;text-decoration:none}
a:hover{color:#000;text-decoration:underline}
</style>
</head><body>
<?


if($_GET['info_hash'] && file_exists($_GET['info_hash']))
{

	echo '<h1>Hash Status</h1><a href="javascript:history.back(1)">Go Back</a><br /><table cellspacing="0" cellpadding="2"><th>ip</th><th>status</th><th>port</th><th>last action</th>';
	$handle = fopen($_GET['info_hash'], "rb+");
	flock($handle, LOCK_EX);
	$x = fread($handle, filesize($_GET['info_hash']));
	flock($handle, LOCK_UN);
	fclose($handle);
	$no_peers = intval(strlen($x) / 7);
	for($j=0;$j<$no_peers;$j++)
	{
		$ip = unpack("C*", substr($x, $j * 7 + 1, 4));
		$ip = $ip[1] . '.' . $ip[2] . '.' . $ip[3] . '.*';
		$port = join('', unpack("n*", substr($x, $j * 7 + 5, 2)));
		$t_peer_seed = join('', unpack("C", substr($x, $j * 7, 1)));
		if($t_peer_seed >= 128)
		{
			$what = '<strong>seeder</strong>';
			$t_time = $t_peer_seed - 128;
		}
		else
		{
			$what = 'peer';
			$t_time = $t_peer_seed;
			
		}
		$time = intval((time() % 7680) / 60);

		echo '<tr><td>'.$ip.'</td><td>'.$what.'</td><td>'.$port.'</td><td>'.number_format($time - $t_time).' min. ago</td></tr>';
	}
	echo '</table><a href="javascript:history.back(1)">Go Back</a>';
	}
else
{
?>
<h1>Tracker Swarm</h1>
<table cellspacing="0" cellpadding="1"><th>Hash</th><th>seeds</th><th>peers</th>
<?
$handle = opendir('.');
while (false !== ($file = readdir($handle)))
{
	if(strlen($file) == 40)
	{

		$handle = fopen($file, "rb+");
	flock($handle, LOCK_EX);
	$x = fread($handle, filesize($file));
	flock($handle, LOCK_UN);
	fclose($handle);
	$no_peers = intval(strlen($x) / 7);
	for($j=0;$j<$no_peers;$j++)
	{
		$t_peer_seed = join('', unpack("C", substr($x, $j * 7, 1)));
		if($t_peer_seed >= 128)
		{
			$complete++;
		}
		else
		{
			$incomplete++;
		}
	}
echo '<tr><td><a href="index.php?info_hash='.$file.'">'.$file.'</a></td><td>'.number_format($complete).'</td><td>'.number_format($incomplete).'</td></tr>';
	}
}
closedir($handle);?>
</table>
<?
}
?>

</body>
</html>
